View Issue Details

IDProjectCategoryView StatusLast Update
0004652administrationenhancepublic2013-01-17 23:30
Reporteravij 
PrioritynormalSeverityminorReproducibilityN/A
Status resolvedResolutionfixed 
Product Version 
Target VersionFixed in Version 
Summary0004652: IPv6 tracker for CentOS torrents
DescriptionHi, would it be possible to add an IPv6-capable tracker to the CentOS torrents? Currently the only tracker in the CentOS torrents is torrent.centos.org and it has only an IPv4 address. If you don't want to set up a separate IPv6 tracker for CentOS, you could use ipv6tracker.org in addition to torrent.centos.org.

Obviously nearly all IPv6-capable peers are also able to connect to IPv4 trackers, so that's not the problem. The problem is how the tracker gets to know the client's IPv6 address if the client connects to the tracker with IPv4. There are BitTorrent protocol extensions that allow the client to include the IPv6 address in the data when connecting to the tracker, but my experience shows that most trackers seem to either not implement those protocol extensions, or intentionally disregard any extra IP address information. By having a tracker with an IPv6 address, the tracker can simply record the source address of the connection.
TagsQA-5.9, QA-6.4

Activities

avij

avij

2010-12-12 19:49

updater   ~0012220

According to http://www.mail-archive.com/dev@distribution.openoffice.org/msg00934.html and http://wiki.openstreetmap.org/wiki/Talk:Planet.osm#Torrent , it might be useful to add the/those ipv6 capable tracker(s) to a second primary group of trackers.
yognandni2010

yognandni2010

2011-05-11 13:30

reporter   ~0012733

agaege
neufeind

neufeind

2011-07-04 01:41

reporter   ~0012879

One tracker ipv4-only, other ipv6-only. Both listed as primary. Works fine for a larger tracker I'm involved with.
avij

avij

2011-09-03 16:35

updater   ~0013195

I was wondering if you'd accept that someone else would maintain the IPv6 torrent tracker. I'd be willing to maintain that IPv6 torrent tracker and pay the related hosting costs.

I have now set up an instance of opentracker on my server and modified some CentOS6 torrents to add a tracker URL pointing to ipv6.torrent.centos.org. I also have a separate torrent seedbox (elsewhere) on IPv6, and it seems to communicate properly with the new tracker (after adding an entry to /etc/hosts to override the DNS, that is). You can also get access to that tracker server if it's desired.

The necessary next steps would be:

1) Add an AAAA record ipv6.torrent.centos.org pointing to 2001:1bc8:100:18::1:102

2) Modify the torrent creation scripts to include "-a http://torrent.centos.org:6969/announce -a http://ipv6.torrent.centos.org:6969/announce". Please note that "-a URL1,URL2" would create a different kind of torrent than "-a URL1 -a URL2". The "-a URL1 -a URL2" method is preferred as it'll create two separate tracker groups.

3) (optional) Get the modified CentOS6 torrents from http://norsu.miuku.net/torrents/ipv6/ and place them in the appropriate place so that they'd get used for any new CentOS6 downloads. Please note that even though the torrents have been modified to include an additional tracker, the info hash is unchanged. This means that the torrent swarm won't be split even if someone now starts using the new torrents. Using these modified torrents now would enable us to test the new tracker with a bit less traffic, as compared to trying the new tracker only when C6.1/C5.7 is eventually released.

4) Notify me when any new torrents are available. opentracker is currently operating in "whitelist" mode, meaning that someone will need to tell it about any new torrents.

http://torrenteditor.com/ can be used to easily examine/edit the torrents.

I'm also available on #centos-mirror for further questions.
avij

avij

2011-10-23 14:50

updater   ~0013600

There's now a script which downloads the info hashes from the IPv4 tracker and tells the IPv6 tracker to use them. This script has been placed in the IPv6 tracker's crontab so it'll be executed periodically. The script can be found from http://tursas.miuku.net/tracker/

This means you can scratch #4 from the previous todo list, so it's now down to two steps and one optional step. If there's anything else I could do to advance this IPv6 tracker project, please let me know.
avij

avij

2012-08-31 16:33

updater   ~0015726

Last edited: 2012-09-01 11:27

View 2 revisions

Server consolidation in progress ..

tursas.miuku.net is no more. The new link for the tracker files is http://villisika.miuku.net/tracker/ and the proposed IPv6 address for ipv6.torrent.centos.org is now 2001:4b98:dc0:41:216:3eff:fe69:46e3. Alternatively, you could make ipv6.torrent.centos.org a CNAME to ipv6tracker.miuku.net. This would give me some flexibility in arranging the tracker server resources.

norsu.miuku.net will also be shut down in about a month. To make the modified torrents available even after that server is shut down, I have copied the torrents to http://villisika.miuku.net/torrents/

avij

avij

2012-09-06 15:30

updater   ~0015749

When CentOS 5.9 and 6.4 are eventually released, they should reference both IPv4 and IPv6 trackers. Tagging this bug as QA-6.4, QA-5.9.
avij

avij

2013-01-17 23:06

updater   ~0016293

CentOS 5.9 was released yesterday, with torrents pointing to torrent.centos.org and ipv6.torrent.centos.org, so this bug can now be closed.

Issue History

Date Modified Username Field Change
2010-12-01 22:00 avij New Issue
2010-12-12 19:49 avij Note Added: 0012220
2011-05-11 13:30 yognandni2010 Note Added: 0012733
2011-07-04 01:41 neufeind Note Added: 0012879
2011-09-03 16:35 avij Note Added: 0013195
2011-10-23 14:50 avij Note Added: 0013600
2012-08-31 16:33 avij Note Added: 0015726
2012-09-01 11:27 avij Note Edited: 0015726 View Revisions
2012-09-06 15:30 avij Note Added: 0015749
2012-09-06 15:30 avij Tag Attached: QA-6.4
2012-09-06 15:30 avij Tag Attached: QA-5.9
2013-01-17 23:06 avij Note Added: 0016293
2013-01-17 23:06 avij Status new => closed
2013-01-17 23:06 avij Resolution open => fixed
2013-01-17 23:30 kbsingh@karan.org Status closed => resolved